package klaverjassen;

import java.util.*;

public class Klaverjassen {

    public static Speler[] spelers = new Speler[4];
    private static int troef;
    private static int aantalRonden;
    private static int startspeler;
    public static Tafel tafel;
    private static int rondesGespeeld;
    private static boolean rondeBezig, rondeGeeindigd;
    private static int[][] rondeScores;

    private static void init() {
        rondeBezig = false;
        rondeGeeindigd = false;
        rondesGespeeld = 0;
        aantalRonden = 16;
        tafel = new Tafel();
        rondeScores = new int[aantalRonden][2];
        rondeBezig = false;
    }

    private static void initSpelers() {
        ArrayList deck = maakKaartDeck();
        for (int i = 0; i < 4; i++) {
            spelers[i] = new Speler(i, tafel);
        }
        verdeelKaarten(deck, spelers);
        troef = 0;
        for (int i = 0; i < 4; i++) {
            spelers[i].trimHand();
        }
    }

    private static ArrayList maakKaartDeck() {
        // Genereer een geschud deck met kaarten.
        ArrayList deck = new ArrayList();
        int teller = 0;
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 8; j++) {
                Kaart kaart = new Kaart(j, i);
                deck.add(kaart);
                teller++;
            }
        }
        Collections.shuffle(deck);
        return deck;
    }

    private static void verdeelKaarten(ArrayList deck, Speler[] spelers) {
        // Verdeel de kaarten uit een deck over de spelers.
        for (int i = 0; i < 32; i++) {
            spelers[(i % 4)].setCard((Kaart) deck.get(i));
        }
    }

    private static void startHetSpel(int ronde) {
        //Begin het spel
        if (ronde == 0) {
            startspeler = (int) Math.round(Math.random() * 4);
            if (startspeler == 4) {
                startspeler--;
            }
        } else {
            startspeler = (startspeler + 1) % 4;
        }

        tafel.setStartspeler(startspeler);
        System.out.println("Speler " + startspeler + " begint.");

        boolean nietGekozen = true;
        int speler = startspeler;
        do {
            if (spelers[speler].wilTroef(troef, startspeler)) {
                nietGekozen = false;
                tafel.setSpeelt(speler);
            } else {
                speler = (speler + 1) % 4;
            }
        } while (nietGekozen && speler != startspeler);
        if (nietGekozen) {
            troef = spelers[startspeler].kiesTroef(troef);
            tafel.setSpeelt(startspeler);
        }
        tafel.setTroef(troef);

        // Laat de agents met het spel beginnen.
        spelers[startspeler].setTurn();
        for (int i = 0; i < 4; i++) {
            spelers[i].start();
        }

        rondeBezig = true;

    }

    private static void bepaalRondeScore() {
        Kaart[][] slagen = tafel.getSlagen();
        int[] winnaars = tafel.getWinnaars();
        int slagScore;

        for (int i = 0; i < 8; i++) {
            slagScore = 0;
            for (int j = 0; j < 4; j++) {
                slagScore += slagen[i][j].getPuntWaarde(troef);
            }
            rondeScores[rondesGespeeld][winnaars[i] % 2] += slagScore;
            if (i == 7) {
                rondeScores[rondesGespeeld][winnaars[i] % 2] += 10;
            }
        }
        if (rondeScores[rondesGespeeld][tafel.getSpeelt() % 2] < 82) {
            rondeScores[rondesGespeeld][tafel.getSpeelt() % 2] = 0;
            rondeScores[rondesGespeeld][(tafel.getSpeelt() + 1) % 2] = 162;
        }
        if (((rondesGespeeld + 1) % 4) == 0) {
            int score0 = 0;
            int score1 = 0;
            for (int i = 0; i < rondesGespeeld + 1; i++) {
                score0 = score0 + rondeScores[i][0];
                score1 = score1 + rondeScores[i][1];
            }
            System.out.println("De Score van team 0 is: " + score0);
            System.out.println("De Score van team 1 is: " + score1);
        }
    }

    public static void setRondeBezig(boolean bezig) {
        if (!bezig) {
            System.out.println("ronde afgelopen");
        }
        rondeBezig = bezig;
    }

    public static void setEindeRonde() {
        rondeGeeindigd = true;
    }

    public static void main(String[] args) {
        init();
        while (rondesGespeeld < aantalRonden) {
            if (!rondeBezig) {
                initSpelers();
                startHetSpel(rondesGespeeld);
            }
            if (rondeGeeindigd) {
                System.out.println("ronde is klaar");
                bepaalRondeScore(); // vorige ronde is afgelopen. bepaal score per tweetal
                System.out.println("!--- Dit was Ronde " + rondesGespeeld + " " + "---!");
                tafel.reset();
                rondesGespeeld++;
                rondeBezig = false;
                rondeGeeindigd = false;
            }
        }
        System.out.println("het spel is klaar");
    }
}