/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package klaverjassen;

import java.util.*;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Joris & Wolter
 */
public class Speler implements Runnable {

    private int id;
    private String[][] kaarten = new String[4][8];
    private ArrayList hand = new ArrayList();
    private boolean turn = false;
    private Kaart volgendeKaart;
    Thread thread;
    Tafel tafel;
    boolean beurtGeweest;
    Boolean[] aanSein = {false, false, false, false};//
    Boolean[] afSein = {false, false, false, false};//

    public void start() {
        thread = new Thread(this);
        thread.setName("speler" + id);
        thread.start();
    }

    public Speler(int id, Tafel tafel) {
        this.id = id;
        this.tafel = tafel;
        beurtGeweest = false;
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 8; j++) {
                kaarten[i][j] = "geenidee";
            }
        }
    }

    @Override
    public void run() {
        while (!hand.isEmpty()) {
            redeneer();
            if (this.turn) {
                try {
                    synchronized (this) {
                        // om te voorkomen dat hij notify doet voordat de ander wait heeft gedaan
                        wait(10);
                    }
                } catch (InterruptedException ex) {
                    System.out.println("HET GAAT ALLEMAAL MIS!");
                }
                speelKaart();
            } else {
                try {
                    synchronized (this) {
                        wait();
                    }
                } catch (InterruptedException ex) {
                    Logger.getLogger(Speler.class.getName()).log(Level.SEVERE, null, ex);
                    System.out.println("HET GAAT ALLEMAAL MIS!");
                }
            }
        }
        System.out.println("Speler " + this.id + " is klaar met de ronde.");
    }

    private void redeneer() {
        /*
         * Mogelijke beliefs over kaarten: hand = speler heeft de kaart op
         * handen pSX = de kaart is gespeeld, in slag S, door speler X geenidee
         * = de speler heeft geen idee waar de kaart is bX = gelooft dat speler
         * X de kaart heeft nx = de speler gelooft dat speler x de kaart niet
         * heeft
         */
        //Update je beliefs over gespeelde kaart
        Kaart laatste = tafel.getLaatsteKaart();
        if (tafel.getCurrentSlag() != 0) {
            if (laatste != null) {
                updateBeliefGespeeld(laatste);
                int huidigeSlag = tafel.getCurrentSlag();
                int laatsteKleur = laatste.getKleur();
                int laatsteWaarde = laatste.getPositie();
                int laatsteSpeler = (this.id + 3) % 4;
                //kijk of er geseind is
                if (laatsteKleur != -1 && laatsteWaarde != -1) {
                    checkSein(huidigeSlag, laatsteKleur, laatsteSpeler, laatsteWaarde);
                    if (laatsteKleur != tafel.getSlagKleur()) { // speler heeft geen kleur bekend
                        for (int i = 0; i < 8; i++) {
                            if (kaarten[laatsteKleur][i].equals("geenidee")) {
                                kaarten[laatsteKleur][laatsteWaarde] = "n" + (this.id + 4) % 4;
                            }
                        }
                    }
                }
            } else {
                //kijk nog even naar de laatste slag
                int huidigeSlag = tafel.getCurrentSlag() - 1;
                Kaart[] slag = tafel.getSlag(huidigeSlag);
                int laatsteSpeler = (tafel.getStartspeler(huidigeSlag) + 3) % 4;
                laatste = slag[laatsteSpeler];
                int laatsteKleur = laatste.getKleur();
                int laatsteWaarde = laatste.getPositie();

                if (laatsteKleur != -1 && laatsteWaarde != -1) {
                    kaarten[laatsteKleur][laatsteWaarde] = "p" + huidigeSlag + laatsteSpeler;
                    if (laatsteKleur != tafel.getSlagKleur()) {
                        //Speler heeft geen kleur bekend
                        for (int i = 0; i < 8; i++) {
                            if (kaarten[laatsteKleur][i].equals("geenidee")) {
                                kaarten[laatsteKleur][laatsteWaarde] = "n" + (this.id + 4) % 4;
                            }
                        }
                        checkSein(huidigeSlag, laatsteKleur, laatsteSpeler, laatsteWaarde);

                    }
                }
            }
        } else {
            //het is de eerste slag.
            if (laatste != null) {
                updateBeliefGespeeld(laatste);
            }
        }

        if (turn) {
            volgendeKaart = new Kaart();
            int aantalTroeven = telEigenTroeven(tafel.getTroef());
            int totaalTroeven = telAlleTroeven();
            int tegenstanderTroeven = telTegenstanderTroeven();
            boolean[] hoogsteKleuren = hoogsten();//array met of je de hoogste hebt
            int troef = tafel.getTroef();
            boolean trekTroef = false; // bepaal of je troeven wilt trekken

            if (aantalTroeven > 0 && totaalTroeven - aantalTroeven > 0 && tegenstanderTroeven > 0) {
                trekTroef = true;
            }

            //Bepaal volgende kaart

            if (id == tafel.getStartspeler()) {
                //startspeler, is er geseind? Welke kaarten zijn hoog? Troeven trekken?

                komUit(trekTroef, hoogsteKleuren, aanSein, afSein);
                /*
                 * } else if (this.id == (tafel.getStartspeler() + 3 ) % 4) {
                 * //TODO: laatste in de slag zijn, niet echt nodig, maakt bots
                 * wel iets beter. // is dit wel nodig? zit het niet al
                 * automatisch in de andere functies? Kaart[] gespeeldeKaarten =
                 * tafel.getSlag(tafel.getCurrentSlag()); int slagKleur =
                 * tafel.getSlagKleur(); boolean maatHoogste = false; if
                 * (slagKleur != -1) { maatHoogste = maatHoogste(slagKleur); }
                 * if (heeftKleur(slagKleur)) { // gooi kaart van gewilde kleur
                 * op } else if (maatHoogste) {
                 *
                 * } else { }
                 */
            } else {
                /**
                 * speler 2 en 3 en nu nog 4
                 */
                //niet startspeler, beken kleur. Als dat niet kan, seinen of troeven of spekken?
                int huidigeKleur = tafel.getSlagKleur();
                boolean gespeeld = false;
                boolean maatHoogste = maatHoogste(huidigeKleur);

                // Kijk  of je de te spelen kleur hebt
                if (hebKleur(huidigeKleur)) {
                    if (hoogsteKleuren[huidigeKleur]) {
                        gespeeld = bedienHoog(huidigeKleur); // speel hoogste als mogelijk 
                    }
                    if (maatHoogste && !gespeeld) {
                        gespeeld = bedienMaat(huidigeKleur);// speel spekken
                    }
                    if (!gespeeld) {
                        gespeeld = bedienLaag(huidigeKleur); // speel maar laag als je toch niks goed hebt
                    }
                } else {
                    // geval waarin je niet de kleur hebt die gevraagd wordt
                    if (tafel.slagLigtAan() == (this.id + 2) % 4) {
                        //slag ligt aan maat, er is nog 1 iemand na je
                        if (!tegenstanderHeeftKleur(huidigeKleur) && tegenstanderHeeftKleur(troef)) {
                            //de speler na jou gaat introeven
                            gespeeld = bedienLaaghoogSein();
                            if (!gespeeld) {
                                gespeeld = speelLaagsteAndere();
                            }
                        } else {
                            //tegenstander gaat waarschijnlijk niet troeven
                            gespeeld = bedienOngedekteTien();//spek met een 10
                            if (!gespeeld) {
                                gespeeld = bedienAasTienSein();//sein dat je aas tien hebt en spek met de aas
                            }
                            if (!gespeeld) {
                                gespeeld = bedienLaaghoogSein();
                            }
                            if (!gespeeld) {
                                gespeeld = bedienSpek();//gooi een tien bij
                            }
                        }
                        if (!gespeeld) {
                            speelLaagsteAndere();
                        }
                        boolean troeven = true;
                        if (!gespeeld && hebKleur(tafel.getTroef())) {
                            troeven = troeven();
                        }
                        if (!gespeeld && (!troeven || !hebKleur(tafel.getTroef()))) {
                            speelLaagsteAndere();
                        }
                    } else {
                        //slag ligt aan de tegenstander
                        boolean overtroeven = false;
                        if (hebKleur(tafel.getTroef())) { // introeven/overtroeven als je kunt
                            if (!troeven()) {
                                overtroeven = true;
                            }
                        }
                        if (!hebKleur(tafel.getTroef())) {
                            gespeeld = speelLaagsteAndere();
                        }
                        if (overtroeven && !gespeeld) {
                            ondertroeven();
                        }
                    }
                }
            } // einde geval waar je moet spelen, maar je niet uitkomt
        } // einde van stuk wanneer het jouw beurt is
    } // einde redeneren

    private void checkSein(int huidigeSlag, int laatsteKleur, int laatsteSpeler, int laatsteWaarde) {
        if (laatsteKleur == tafel.getTroef() && (laatsteWaarde == 7 || laatsteWaarde == 3 || laatsteWaarde == 2)) {
            //hij speelde een tien, nel of aas
            if (tafel.getAantalKaartenInSlag() == 1 && erZijnNogHogeren(tafel.getTroef(), laatsteWaarde)) {
                // er is 1 kaart gespeeld
            }
        }

        int hoogsteVanKleur = getHoogste(laatsteKleur);
        if (hoogsteVanKleur == -1) {
            return;
        }
        if (huidigeSlag < 6 && laatsteKleur != tafel.getTroef()) {
            //sein alleen de eerste vijf beurten, daarna is de kans dat iemand maar wat opgooit te groot
            //als het troef is is het sowieso geen sein.
            if (laatsteSpeler == (this.id + 2) % 4) {
                //Speler was je maat, kijk of hij geseind heeft.
                if (laatsteWaarde < 3 || laatsteWaarde == 7) {
                    //7,8,9 of Aas gespeeld, aansein?
                    aanSein[laatsteKleur] = true;
                    if (!kaarten[laatsteKleur][hoogsteVanKleur].equals("hand")) {
                        kaarten[laatsteKleur][hoogsteVanKleur] = "b" + laatsteSpeler;
                    }
                } else if (laatsteWaarde == 2 || laatsteWaarde == 3 || laatsteWaarde == 4) {
                    //boer, vrouw, heer, afsein?
                    afSein[laatsteKleur] = true;
                    if (kaarten[laatsteKleur][hoogsteVanKleur].equals("geenidee")) {
                        kaarten[laatsteKleur][hoogsteVanKleur] = "n" + laatsteSpeler;
                    }
                }

            } else {
                if (laatsteWaarde < 3 || laatsteWaarde == 7) {
                    //7,8,9 of Aas gespeeld, aansein?
                    afSein[laatsteKleur] = true;
                    if (!kaarten[laatsteKleur][hoogsteVanKleur].equals("hand")) {
                        kaarten[laatsteKleur][hoogsteVanKleur] = "b" + laatsteSpeler;
                    }
                }
            }
        }
    }

    private void komUit(boolean trekTroef, boolean[] hoogsteKleuren, Boolean[] aanSein, Boolean[] afSein) {
        // Is startspeler
        boolean gespeeld = false;

        if (trekTroef) {
            speelTroef();
            gespeeld = true;
            System.out.println("speeltroef" + " " + gespeeld);
        } else if (hoogsteKleuren[0] || hoogsteKleuren[1] || hoogsteKleuren[2] || hoogsteKleuren[3] && !gespeeld) {
            gespeeld = speelHoog(hoogsteKleuren);

        }
        if ((aanSein[0] || aanSein[1] || aanSein[2] || aanSein[3]) && !gespeeld) {
            //Je maat had geseind, bedien
            gespeeld = speelAangeseind();
        }
        if ((afSein[0] || afSein[1] || afSein[2] || afSein[3]) && !gespeeld) {
            //Maat heeft afgeseind, gooi wat anders dan dat.
            gespeeld = speelAfgeseind();
        }
        if (!gespeeld) {
            // you're screwed, speel een lage troep kaart en trek bij voorkeur troeven van de tegenstander.
            gespeeld = komUitLaag();
        }
        if (!gespeeld) {
            System.out.println("dit kan eigenlijk niet");
        }
    }

    private boolean troeven() {
        int slag = tafel.getCurrentSlag();
        int troef = tafel.getTroef();
        Kaart[] gespeeld = tafel.getSlag(slag);
        if (gespeeld[0].getKleur() == troef || gespeeld[1].getKleur() == troef || gespeeld[2].getKleur() == troef || gespeeld[3].getKleur() == troef) {
            // Er is al troef gespeeld dus overtroeven
            if (overtroeven(troef, gespeeld)) {
                return true;
            }
        } else {
            // je bent de eerste die troeft
            speelTroef();
            return true;
        }
        return false;
    }

    private boolean overtroeven(int troef, Kaart[] gespeeld) {
        int count = Math.abs(tafel.getStartspeler() - this.id);
        int hoogteGespeeldeTroef = -1;
        // Kijk welke troef je overheen moet
        for (int i = 0; i < 4; i++) {
            if (gespeeld[i].getKleur() == troef) {
                if (tafel.getHoogte(i, troef) > hoogteGespeeldeTroef);
                {
                    hoogteGespeeldeTroef = tafel.getHoogte(i, troef);
                }
            }
        }
        // Kijk of je een troef hebt waarmee je kunt overtroeven
        int laagsteHogeTroefInHand = 1337;
        for (int i = 0; i < 8; i++) {
            if (kaarten[troef][i].equals("hand") && tafel.getHoogte(i, troef) > hoogteGespeeldeTroef && tafel.getHoogte(i, troef) < laagsteHogeTroefInHand) {
                laagsteHogeTroefInHand = tafel.getHoogte(i, troef);
            }
        }

        if (laagsteHogeTroefInHand == 1337) { // we hebben geen troef die hoger is dan al gespeelde. dus kunnen niet overtroeven
            return false;
        }

        // je wilt de slag pakken? dus kijken welke troef je hiervoor kunt spelen op basis van wat je weet van andere spelers      
        // bepaal hoogste troef in hand
        int hoogsteTroefInHand = hoogsteInHand(troef);

        int hoogsteTroefInSpel = -1;
        // bepaal hoogste troef in spel bij spelers die nog na jou moeten
        for (int i = 0; i < 8; i++) {
            if (tafel.getHoogte(i, troef) > hoogsteTroefInSpel) {
                if (kaarten[troef][i].equals("geenidee")) {
                    hoogsteTroefInSpel = tafel.getHoogte(i, troef);
                } else {
                    for (int j = this.id + 1; i < this.id + count; i++) {
                        if (kaarten[troef][i].equals("b" + j)) {
                            hoogsteTroefInSpel = tafel.getHoogte(i, troef);
                        }
                    }
                }
            }
        }

        // als je de hoogste hebt speel je die
        if (tafel.getHoogte(hoogsteTroefInHand, troef) > hoogsteTroefInSpel && hoogsteTroefInHand != 1337) {
            volgendeKaart.setPositie(hoogsteTroefInHand);
            volgendeKaart.setKleur(troef);
            return true;
        } else if (laagsteHogeTroefInHand != 1337) {
            volgendeKaart.setPositie(tafel.getPositie(laagsteHogeTroefInHand, troef));
            volgendeKaart.setKleur(troef);
            return true;
        }
        return false;
    }

    private boolean ondertroeven() {
        int troef = tafel.getTroef();
        volgendeKaart.setPositie(getLaagste(troef));
        volgendeKaart.setKleur(troef);
        return true;
    }

    private boolean speelLaagsteAndere() {
        int troef = tafel.getTroef();
        int kleur = -1;
        int laagste = 1337;
        for (int i = 0; i < 4; i++) {
            if (i != troef) {
                for (int j = 0; j < 8; j++) {
                    if (kaarten[i][j].equals("hand") && tafel.getHoogte(j, i) < tafel.getHoogte(laagste, kleur)) {
                        laagste = j;
                        kleur = i;
                    }
                }
            }
        }

        if (kleur == -1 || laagste == 1337) {
            //je hebt alleen troef in hand
            kleur = troef;
            laagste = laagsteInHand(tafel.getTroef());
        }
        volgendeKaart.setKleur(kleur);
        volgendeKaart.setPositie(laagste);
        return true;
    }

    private boolean speelHoog(boolean[] hoogsteKleuren) {
        //speel een hoogste kaart.
        int aantalHoogsten = 0;
        for (int i = 0; i < 4; i++) {
            if (hoogsteKleuren[i]) {
                aantalHoogsten++;
            }
        }
        if (aantalHoogsten == 1) {
            for (int i = 0; i < 4; i++) {
                if (hoogsteKleuren[i]) {
                    volgendeKaart.setKleur(i);
                    volgendeKaart.setPositie(hoogsteInHand(i));
                    return true;
                }
            }
        } else {
            int meesteAantal = 0;
            int meesteKleur = -1;
            for (int i = 0; i < 4; i++) {
                if (hoogsteKleuren[i]) {
                    int aantal = aantalInSpel(i);
                    if (aantal > meesteAantal) {
                        meesteAantal = aantal;
                        meesteKleur = i;
                    }
                }
            }
            if (meesteAantal - aantalInHand(meesteKleur) > 3 && telTegenstanderTroeven() > 0) {
                volgendeKaart.setKleur(meesteKleur);
                volgendeKaart.setPositie(hoogsteInHand(meesteKleur));
                return true;
            }
        }
        return false;
    }

    private boolean bedienHoog(int kleur) {
        if (kleur != tafel.getTroef()) {
            if (telTroefSpeler((this.id + 1) % 4) == 0) {
                //Tegenstander heeft geen troeven, lekker uitspelen dus.
                volgendeKaart.setKleur(kleur);
                volgendeKaart.setPositie(hoogsteInHand(kleur));
                return true;
            } else {
                //de speler na jou heeft geen troef, speel maar gewoon
                volgendeKaart.setKleur(kleur);
                volgendeKaart.setPositie(hoogsteInHand(kleur));
                return true;
            }
        } else {
            // speel je hoogste troef
            volgendeKaart.setKleur(kleur);
            volgendeKaart.setPositie(hoogsteInHand(kleur));
            return true;

        }
    }

    private int telTroefSpeler(int speler) {
        //telt hoeveel een tegenstander mogelijk heeft
        int teller = 0;
        for (int i = 0; i < 7; i++) {
            if (kaarten[tafel.getTroef()][i].equals("b" + speler) || kaarten[tafel.getTroef()][i].equals("geenidee")) {
                teller++;
            }
        }


        return teller;
    }

    private void speelTroef() {
        //speel een troef
        int troef = tafel.getTroef();
        volgendeKaart.setKleur(tafel.getTroef());
        int hoogsteKaart = hoogsteInHand(troef);
        if (getHoogste(troef) == hoogsteKaart) {
            //Je hebt de hoogste, check of je de of je meer hoogsten hebt.
            int laagsteHoge = getLaagsteHoge(troef, hoogsteKaart);
            if (laagsteHoge != hoogsteKaart) {
                // update je 2nd order belief over seinen.
            }
            volgendeKaart.setPositie(laagsteHoge);
        } else {
            // trek troef  en kom uit met de laagste of kom uit met een medium als je maat de hoogste heeft.
            if (maatHoogsteTroef()) {
                volgendeKaart.setPositie(getMedium(troef));
            } else {
                volgendeKaart.setPositie(getLaagste(troef));
            }
        }
    }

    private int telEigenTroeven(int troef) {
        //Tel troeven
        int aantaltroeven = 0;
        for (int i = 0; i < 8; i++) {
            if (kaarten[troef][i].equals("hand")) {
                aantaltroeven++;
            }
        }
        return aantaltroeven;
    }

    private void updateBeliefGespeeld(Kaart laatste) {
        if (laatste.getKleur() != -1 && laatste.getPositie() != -1) {
            if (this.id != 0) {
                kaarten[laatste.getKleur()][laatste.getPositie()] = "p" + tafel.getCurrentSlag() + (this.id - 1);
            } else {
                kaarten[laatste.getKleur()][laatste.getPositie()] = "p" + tafel.getCurrentSlag() + 3;
            }

        }
    }

    private void speelKaart() {
        //speel een kaart
        for (int i = 0; i < hand.size(); i++) {
            if (volgendeKaart.toString().equals(hand.get(i).toString())) {
                hand.remove(i);
                hand.trimToSize();
                kaarten[volgendeKaart.getKleur()][volgendeKaart.getPositie()] = "p" + tafel.getCurrentSlag() + this.id;
            }
        }
        this.turn = false;
        System.out.println("speler: " + this.id + "	speelt: " + volgendeKaart.toString());
        tafel.speelKaart(volgendeKaart, this.id);
        if (this.id == tafel.getStartspeler()) {
            tafel.setSlagKleur(volgendeKaart.getKleur());
        }
    }

    public void setCard(Kaart kaart) {
        hand.add(kaart);
        kaarten[kaart.getKleur()][kaart.getPositie()] = "hand";
    }

    public boolean wilTroef(int troef, int voorzitter) {
        //Kijk of de speler de boer en nel heeft
        boolean boer = false, nel = false;
        if (kaarten[troef][2].equals("hand")) {
            nel = true;
        }
        if (kaarten[troef][4].equals("hand")) {
            boer = true;
        }
        int aantaltroeven = telEigenTroeven(troef);
        //Tel het aantal niet troef azen
        int azen = 0;
        for (int i = 0; i < 4; i++) {
            if (kaarten[i][7].equals("hand") && i != troef) {
                azen++;
            }
        }
        //Check op niet troef gedekte tienen
        boolean gedekteTien = false;
        for (int i = 0; i < 4; i++) {
            if (i != troef && kaarten[i][3].equals("hand")) {
                for (int j = 0; j < 8; j++) {
                    if (j != 3 && kaarten[i][j].equals("hand")) {
                        gedekteTien = true;
                    }
                }
            }
        }

        //Kijk of hij wil spelen
        boolean spelen;
        if ((boer && nel && azen > 0) || (boer && azen > 0 && aantaltroeven > 2)
                || (boer && gedekteTien && azen > 0) || (nel && aantaltroeven > 3)
                || (nel && azen > 0 && aantaltroeven > 2)) {
            spelen = true;
        } else {
            spelen = false;
        }

        boolean zitVoor;
        zitVoor = this.id == voorzitter;
        int[] waarden = bepaalTroefWaarden();
        if (spelen && zitVoor && waarden[kiesTroef(troef)] > waarden[troef]) {
            spelen = false;
        }
        return spelen;
    }

    public int kiesTroef(int troef) {
        // kies een troef
        int[] waarden = bepaalTroefWaarden();
        waarden[troef] = 0;
        int maximum = 0;
        int maxkleur = 1337;
        for (int i = 0; i < 4; i++) {
            if (maximum < waarden[i]) {
                maximum = waarden[i];
                maxkleur = i;
            }
        }
        return maxkleur;
    }

    private int[] bepaalTroefWaarden() {
        // voor troefkeuze
        int[] troefwaarden = {2, 2, 14, 10, 20, 3, 4, 11};
        int[] waarden = new int[4];
        for (int i = 0; i < 4; i++) {
            waarden[i] = 0;
            for (int j = 0; j < 8; j++) {
                if (kaarten[i][j].equals("hand")) {
                    waarden[i] += troefwaarden[j];
                }
            }
        }
        return waarden;
    }

    public void setTurn() {
        this.turn = true;
    }

    private int telAlleTroeven() {
        int troef = tafel.getTroef();
        int count = 0;

        for (int i = 0; i < 8; i++) {
            if (!kaarten[troef][i].substring(0, 1).equals("p")) {
                count++;
            }
        }
        return count;
    }

    private int telTegenstanderTroeven() {
        int troef = tafel.getTroef();
        int count = 0;

        for (int i = 0; i < 8; i++) {
            if (kaarten[troef][i].substring(0, 1).equals("b")) {
                int speler = Integer.valueOf(kaarten[troef][i].substring(1, 2));
                if (this.id == 0 || this.id == 2) {
                    if (speler == 1 || speler == 3) {
                        count++;
                    }
                } else {
                    if (speler == 0 || speler == 2) {
                        count++;
                    }
                }

            } else if (kaarten[troef][i].equals("geenidee")) {
                //weet niet waar de kaart zit, ga er van uit dat hij bij de tegenstander zit.
                count++;
            }
        }
        return count;
    }

    private boolean[] hoogsten() {
        boolean[] hoogst = {false, false, false, false};
        for (int i = 0; i < 4; i++) {
            int hoogste = getHoogste(i);
            for (int j = 0; j < 8; j++) {
                // Vergelijk 
                int hoogsteInHand = hoogsteInHand(i);
                if (kaarten[i][j].equals("hand") && hoogsteInHand != 1337 && hoogste == hoogsteInHand && i != tafel.getTroef()) {
                    hoogst[i] = true;
                }
            }
        }
        return hoogst;

    }

    private int getHoogste(int kleur) {
        /*
         * Returnt de hoogste nog niet gespeelde kaart van kleur i
         */
        int hoogste = -1;
        for (int kaart = 0; kaart < 8; kaart++) {
            if (!kaarten[kleur][kaart].substring(0, 1).equals("p")
                    && tafel.getHoogte(kaart, kleur) > tafel.getHoogte(hoogste, kleur)) {
                hoogste = kaart;
            }
        }
        return hoogste;
    }

    private int hoogsteInHand(int kleur) {
        int hoogsteInHand = -1;
        boolean hebIets = false;
        for (int j = 0; j < 8; j++) {
            if (kaarten[kleur][j].equals("hand")
                    && (tafel.getHoogte(j, kleur) > tafel.getHoogte(hoogsteInHand, kleur))) {
                hoogsteInHand = j;
                hebIets = true;
            }
        }
        if (hebIets) {
            return hoogsteInHand;
        }
        return 1337;
    }

    private int laagsteInHand(int kleur) {
        int laagsteInHand = 1337;
        boolean hebIets = false;
        for (int j = 0; j < 8; j++) {
            if (kaarten[kleur][j].equals("hand")
                    && (tafel.getHoogte(j, kleur) < tafel.getHoogte(laagsteInHand, kleur))) {
                laagsteInHand = j;
                hebIets = true;
            }
        }
        if (hebIets) {
            return laagsteInHand;
        } else {
            return 1337;
        }
    }

    private int getLaagsteHoge(int kleur, int hoogste) {
        int hoogsteLage = hoogste;
        boolean loop = true;

        while (loop) {
            if (kaarten[kleur][tafel.getLagere(hoogsteLage, kleur)].equals("hand")) {
                hoogsteLage = tafel.getLagere(hoogsteLage, kleur);
            } else {
                loop = false;
            }
        }
        return hoogsteLage;
    }

    private boolean maatHoogsteTroef() {
        int maat = (this.id + 2) % 4;
        int huidige = -1;
        boolean maatHoog = false;
        int troef = tafel.getTroef();
        for (int i = 0; i < 8; i++) {
            if (kaarten[troef][i].substring(0, 1).equals("b" + maat) && tafel.getHoogte(i, troef) > huidige) {
                huidige = tafel.getHoogte(i, troef);
                maatHoog = true;
            } else if (kaarten[troef][i].substring(0, 1).equals("b") && tafel.getHoogte(i, troef) > huidige) {
                huidige = tafel.getHoogte(i, troef);
                maatHoog = false;
            }
        }
        return maatHoog;
    }

    private int getMedium(int kleur) {
        int troef = tafel.getTroef();
        if (kleur == troef) {
            if (kaarten[kleur][5].equals("hand")) {
                return 5;
            }
            if (kaarten[kleur][6].equals("hand")) {
                return 6;
            }
            if (kaarten[kleur][3].equals("hand")) {
                return 3;
            }
            if (kaarten[kleur][7].equals("hand")) {
                return 7;
            }
            if (kaarten[kleur][1].equals("hand")) {
                return 1;
            }
            if (kaarten[kleur][0].equals("hand")) {
                return 0;
            }
            if (kaarten[kleur][2].equals("hand")) {
                return 2;
            }
        } else {
            if (kaarten[kleur][6].equals("hand")) {
                return 6;
            }
            if (kaarten[kleur][5].equals("hand")) {
                return 5;
            }
            if (kaarten[kleur][4].equals("hand")) {
                return 4;
            }
            if (kaarten[kleur][2].equals("hand")) {
                return 2;
            }
            if (kaarten[kleur][1].equals("hand")) {
                return 1;
            }
            if (kaarten[kleur][0].equals("hand")) {
                return 0;
            }
            if (kaarten[kleur][3].equals("hand")) {
                return 3;
            }
        }
        return -1;
    }

    private int getLaagste(int kleur) {
        if (kleur == tafel.getTroef()) {
            if (kaarten[kleur][0].equals("hand")) {
                return 0;
            }
            if (kaarten[kleur][1].equals("hand")) {
                return 1;
            }
            if (kaarten[kleur][5].equals("hand")) {
                return 5;
            }
            if (kaarten[kleur][6].equals("hand")) {
                return 6;
            }
            if (kaarten[kleur][3].equals("hand")) {
                return 3;
            }
            if (kaarten[kleur][7].equals("hand")) {
                return 7;
            }
            if (kaarten[kleur][2].equals("hand")) {
                return 2;
            }
            if (kaarten[kleur][4].equals("hand")) {
                return 4;
            }
        } else {
            if (kaarten[kleur][0].equals("hand")) {
                return 0;
            }
            if (kaarten[kleur][1].equals("hand")) {
                return 1;
            }
            if (kaarten[kleur][2].equals("hand")) {
                return 2;
            }
            if (kaarten[kleur][4].equals("hand")) {
                return 4;
            }
            if (kaarten[kleur][5].equals("hand")) {
                return 5;
            }
            if (kaarten[kleur][6].equals("hand")) {
                return 6;
            }
            if (kaarten[kleur][3].equals("hand")) {
                return 3;
            }
            if (kaarten[kleur][7].equals("hand")) {
                return 7;
            }
        }
        return -1;
    }

    private int aantalInSpel(int kleur) {
        int aantal = 0;
        for (int i = 0; i < 8; i++) {
            if (!kaarten[kleur][i].substring(0, 1).equals("p")) {
                aantal++;
            }
        }
        return aantal;
    }

    private int aantalInHand(int kleur) {
        int aantal = 0;
        for (int i = 0; i < 8; i++) {
            if (kaarten[kleur][i].equals("hand")) {
                aantal++;
            }
        }
        return aantal;
    }

    private boolean speelAangeseind() {
        for (int i = 0; i < 4; i++) {
            if (aanSein[i] && aantalInHand(i) > 0) {
                volgendeKaart.setKleur(i);
                volgendeKaart.setPositie(hoogsteInHand(i));
                aanSein[i] = false;
                return true;
            }
        }
        return false;
    }

    private boolean speelAfgeseind() {
        for (int i = 0; i < 4; i++) {
            if (!afSein[i] && i != tafel.getTroef() && aantalInHand(i) > 0) {
                //kleur is veilig om te spelen
                volgendeKaart.setKleur(i);
                volgendeKaart.setPositie(getLaagste(i));
                return true;
            }
        }
        return false;
    }

    private Boolean komUitLaag() {
        // Speel een lage kaart. Houd rekening met wat er al van die kleur gespeeld is enzo.
        int troef = tafel.getTroef();

        // Kies een kleur die je maat heeft
        for (int i = 0; i < 4; i++) {
            if (i != troef) {
                if (maatHoogste(i) && telKaartenBijTegenstander(i) >= 2 && laagsteInHand(i) != 1337) {
                    volgendeKaart.setKleur(i);
                    volgendeKaart.setPositie(laagsteInHand(i));
                    return true;
                }
            }
        }
        // kies de kleur waar nog de meesten van zijn
        int hoogsteAantalInSpel = 0;
        int laagsteKleur = 0;
        int laagsteWaarde = 1337;
        for (int i = 0; i < 4; i++) {
            if (i != troef) {
                int aantalInSpel = aantalInSpel(i);
                int laagsteInHand = laagsteInHand(i);
                if (laagsteInHand != 1337 && aantalInSpel > hoogsteAantalInSpel) {
                    laagsteWaarde = laagsteInHand;
                    laagsteKleur = i;
                    hoogsteAantalInSpel = aantalInSpel;
                }
            }
        }

        if (laagsteWaarde == 1337 && this.id == tafel.getStartspeler()) {
            laagsteKleur = troef;
            laagsteWaarde = laagsteInHand(troef);
        }

        volgendeKaart.setKleur(laagsteKleur);
        volgendeKaart.setPositie(laagsteWaarde);
        return true;
    }

    private Boolean bedienLaag(int kleur) {
        // Speel een lage kaart. Houd rekening met wat er al van die kleur gespeeld is enzo.
        int laagste = 1337;
        Boolean returnValue = false;
        for (int i = 0; i < 8; i++) {
            if (kaarten[kleur][i].equals("hand") && tafel.getHoogte(i, kleur) < tafel.getHoogte(laagste, kleur)) {
                laagste = i;
            }
        }

        if (laagste != 1337) {
            volgendeKaart.setPositie(laagste);
            volgendeKaart.setKleur(kleur);
            returnValue = true;
        }
        return returnValue;
    }

    private boolean hebKleur(int kleur) {
        if (!(kleur < 0 || kleur > 3)) {
            for (int i = 0; i < 8; i++) {
                if (kaarten[kleur][i].equals("hand")) {
                    return true;
                }
            }
        }
        return false;
    }

    private boolean ingetroefd() {
        int troef = tafel.getTroef();
        Kaart[] gespeeld = tafel.getSlag(tafel.getCurrentSlag());
        if (troef != tafel.getSlagKleur() && (gespeeld[0].getKleur() != troef && gespeeld[1].getKleur() != troef && gespeeld[2].getKleur() != troef && gespeeld[3].getKleur() != troef)) {
            return false;
        }
        return true;
    }

    private boolean maatHoogste(int kleur) {
        boolean returnValue = false;
        int huidigeHoogste = -1;
        for (int j = 0; j < 8; j++) {
            if (tafel.getHoogte(j, kleur) > tafel.getHoogte(huidigeHoogste, kleur)) {
                if (kaarten[kleur][j].equals("geenidee")) {
                    returnValue = false;
                } else if (kaarten[kleur][j].substring(0, 1).equals("b")) {
                    if (!kaarten[kleur][j].substring(1, 2).equals(Integer.toString((this.id + 2) % 4))) {
                        returnValue = false;
                    } else if (kaarten[kleur][j].substring(1, 2).equals(Integer.toString((this.id + 2) % 4))) {
                        returnValue = true;
                    }
                }

            }
        }
        return returnValue;
    }

    private int telKaartenBijTegenstander(int i) {
        int teller = 0;
        if (this.id == tafel.getStartspeler()) {
            // Startspeler moet alles tellen wat hij niet weet en voor elke tegenstander.
            for (int j = 0; j < 8; j++) {
                if (kaarten[i][j].equals("geenidee") || kaarten[i][j].equals("b" + (this.id + 1) % 4) || kaarten[i][j].equals("b" + (this.id + 3) % 4)) {
                    teller++;
                }

            }
        } else {
            for (int j = 0; j < 8; j++) {
                // Als je niet startspeler bent hoef je de tegenstander die al gespeeld heeft niet meer mee te tellen.
                if (kaarten[i][j].equals("geenidee") || kaarten[i][j].equals("b" + (this.id + 1) % 4)) {
                    teller++;
                }

            }
        }
        return teller;

    }

    private boolean bedienMaat(int kleur) {
        // Je maat heeft een hoge van een kaart, kom ermee uit.
        if (telKaartenBijTegenstander(kleur) > 1) {
            volgendeKaart.setKleur(kleur);
            volgendeKaart.setPositie(hoogsteInHand(kleur));
            return true;
        }
        return false;
    }

    private boolean tegenstanderHeeftKleur(int kleur) {
        for (int i = 0; i < 8; i++) {
            if (kaarten[kleur][i].equals("b" + (this.id + 1) % 4) || kaarten[kleur][i].equals("geenidee")) {
                return true;
            }
        }
        return false;
    }

    private Boolean bedienOngedekteTien() {
        for (int i = 0; i < 4; i++) {
            if (i != tafel.getTroef()) {
                if (kaarten[i][3].equals("hand")) {
                    if (!(kaarten[i][7].equals("geenidee") || kaarten[i][7].equals("b" + (this.id + 1) % 4) || kaarten[i][7].equals("b" + (this.id + 3) % 4))) {
                        volgendeKaart.setPositie(3);
                        volgendeKaart.setKleur(i);
                        return true;
                    }
                }
            }
        }
        return false;
    }

    private boolean bedienAanseinen(boolean[] hoogsten) {
        for (int i = 0; i < 4; i++) {
            if (i != tafel.getTroef() && hoogsten[i]) {
                for (int j = 0; j < 3; j++) {
                    if (kaarten[i][j].equals("hand")) {
                        volgendeKaart.setKleur(i);
                        volgendeKaart.setPositie(j);
                        return true;
                    }
                }
            }
        }
        return false;
    }

    private boolean bedienAfseinen(boolean[] hoogsten) {
        for (int i = 0; i < 4; i++) {
            if (i != tafel.getTroef() && !hoogsten[i]) {
                for (int j = 4; j < 7; j++) {
                    if (kaarten[i][j].equals("hand")) {
                        volgendeKaart.setKleur(i);
                        volgendeKaart.setPositie(j);
                        return true;
                    }
                }
            }
        }
        return false;
    }

    private boolean bedienSpek() {
        //spek met een 10 die niet meer rondkomt.
        for (int kleur = 0; kleur < 4; kleur++) {
            if (kleur != tafel.getTroef() && kaarten[kleur][3].equals("hand") && (telKaartenBijTegenstander(kleur) < 2) && telTegenstanderTroeven() > 0) {
                volgendeKaart.setKleur(kleur);
                volgendeKaart.setPositie(3);
                return true;
            }
        }
        return false;
    }

    public void trimHand() {
        hand.trimToSize();
    }

    private boolean bedienLaaghoogSein() {
        /*
         * Kijk of je de hoogste van een kleur en een lage van die kleur hebt
         */
        for (int i = 0; i < 4; i++) {
            if (i != tafel.getTroef() && i != tafel.getSlagKleur()) {
                //sein dat je de hoogste van een kleur hebt
                if (hoogsteInHand(i) == getHoogste(i) && hebLage(i) && aantalInHand(i) > 2) {
                    volgendeKaart.setKleur(i);
                    volgendeKaart.setPositie(getLaagste(i));
                    return true;
                }
            }
        }
        return false;
    }

    private boolean bedienAasTienSein() {
        /*
         * sein met de aas je 10 aan
         */
        for (int i = 0; i < 4; i++) {
            if (i != tafel.getTroef() && i != tafel.getSlagKleur()) {
                //Aas tien van een kleur en komt sowieso niet 2 keer rond?
                if (hebAasTien(i) && (aantalInHand(i) != 2 || aantalInSpel(i) != 8)) {
                    volgendeKaart.setKleur(i);
                    volgendeKaart.setPositie(getLaagste(i));
                    return true;
                }
            }
        }
        return false;
    }

    private boolean hebLage(int kleur) {
        /*
         * Kijk of je 7,8 of 9 van kleur i hebt
         */
        if (kaarten[kleur][0].equals("hand") || kaarten[kleur][1].equals("hand") || kaarten[kleur][2].equals("hand")) {
            return true;
        }
        return false;

    }

    private boolean hebAasTien(int kleur) {
        /*
         * Kijk of je de aas en de tien van kleur hebt
         */
        if (kaarten[kleur][7].equals("hand") && kaarten[kleur][3].equals("hand")) {
            return true;
        }
        return false;
    }

    private boolean erZijnNogHogeren(int kleur, int positie) {
        for (int i = 0; i < 7; i++) {
            if (!kaarten[kleur][i].substring(0, 1).equals("p") &&tafel.getHoogte(kleur,positie) < tafel.getHoogte(kleur,i)){
                //de kaart is nog niet gespeeld en is hoger dan de net gespeelde.
                return true;
            }
        }

        return false;
    }
}
